topic "QtfEquation";
[ $$0,0#00000000000000000000000000000000:Default]
[H6;0 $$1,0#05600065144404261032431302351956:begin]
[i448;a25;kKO9;2 $$2,0#37138531426314131252341829483370:codeitem]
[l288;2 $$3,0#27521748481378242620020725143825:desc]
[0 $$4,0#96390100711032703541132217272105:end]
[{_} 
[ {{10000@(113.42.0) [s0;%% [*@7;4 Functions4U Reference. QtfEquation]]}}&]
[s1;2 &]
[s0; [2 QtfEquation converts a String with equations or formulas into 
a drawable object able to be painted or included into QTF.]&]
[s0;2 &]
[s0; [2 The functions parse the String searching for expresions and 
convert them into its graphic format.]&]
[s0;2 &]
[s0; [2 Some expressions parsed are:]&]
[s0;i150;O0; [2 Greek symbols]&]
[s0;i150;O0; [2 sqrt(content)]&]
[s0;i150;O0; [2 integral(content, from, to)]&]
[s0;i150;O0; [2 summation(content, from, to)]&]
[s0;i150;O0; [2 `^ as exponent.]&]
[s0;i150;O0; [2 Expressions like `=, `+, `-, `*, /.]&]
[s0;i150;O0; [2 Parenthesis () and brackets `[`].]&]
[s0;2 &]
[s0;2 &]
[ {{10000F(128)G(128)@1 [s0;%% [* Public Method List]]}}&]
[s1; &]
[s2;:QtfEquation`(const String`&`): [_^QtfRichObject^ QtfRichObject]_[* QtfEquation]([@(0.0.255) c
onst]_[_^String^ String]_`&[*@3 str])&]
[s3;%% It converts formulas in [%-*@3 str] into an object ready to 
be inserted into a QTF String.&]
[s4;%% &]
[s1; &]
[s2;:DrawEquation`(const String`&`): [_^Drawing^ Drawing]_[* DrawEquation]([@(0.0.255) cons
t]_[_^String^ String]_`&[*@3 str])&]
[s3;%% It converts formulas in [%-*@3 str] into a Drawing object.&]
[s4;%% &]
[s0;2%% &]
[s0;%% [2 For example, the result of this code:]&]
[s0;C2%% &]
[s0;%% [C2 -|String myqtf;]&]
[s0;C2%% &]
[s0;%% [C2 -|QtfRichObject a `= QtfEquation(`"(2/3)`");]&]
[s0;%% [C2 -|QtfRichObject b `= QtfEquation(`"integral(sqrt(cos(phi`_ini`^2)) 
`+ i`^2 `+ 6, i `= 1, 10)`*dx `= cos((27`+x`^2)`^3.25)/(PI`*R`_0`^2)`");]&]
[s0;%% [C2 -|QtfRichObject c `= QtfEquation(`"delta`_i `= a`+b`*x`+c`*x`^2`+d`*x`^3`");]&]
[s0;%% [C2 -|QtfRichObject d `= QtfEquation(`"sqrt(cos(phi`_ini`^2))`");]&]
[s0;%% [C2 -|QtfRichObject e `= QtfEquation(`"summation(a`+b`*x`+c`*x`^2`+d`*x`^3, 
x `= h, h`+1)`*dx `= SI`_h`");]&]
[s0;%% [C2 -|]&]
[s0;%% [C2 -|myqtf << `"`[R3 This are some formulas in QTF:`&`" << a 
<< `"`&`" << b << `"`&`" << c << `"`&`" << d << `"`&`" << e;]&]
[s0;C2%% &]
[s0;%% [C2 -|equation.SetData(myqtf);]&]
[s0;2%% &]
[s0;2%% &]
[s0;%% [2 is this:]&]
[s0;2%% &]
[s0;%% [2 
@@image:1995&1549
ÜԔɏ̘Ϝ֜΂ፑűĪ㪠Ɣ恜ДĄĲ
˂ГϽè׽ץϋȤɎĢȤɻĢ
ڪ堒Ęʣ􊲷׮ĝܮįўڎޭҒč
砗Ʋ΁ͯ׵ȃܔӨėʕԤʼ
Չ䢜Ι߮тȠ˴ޯթ˳韊ثԦ
˼ɞӔÙɂ̕鮪Ў℃
©Ĥꃚ۩וݔƇԵ硁̕
娬ӦʄƂç˻̸ɟꩦ
勩񂗍˼ˠѥҷ뇹Ľڊ堊᧊ԽɎɔÒԂ
ƢȰĤĢϨߐչǏ۷۶ݠؑٿƢ
◬͛޽𤹢٤֭˗ҤɤĤƎƘР
ƍ䐜ՅЎ񁁁ߦ҅Ĥ꒲Ύ
Ǳ͋ݺˋޓɑۉϿǀܠӒǤĉ
ѥÆޠÇĢѤȑܣ
ᔞĢ֮ʑ͙ڋ˖Ȥⱎ
ǴǢ𦠎⾾آʓ𿇏ݻ͟Ì
ȝώׇ̿ԬĻᄜƆȤϙϿ
ٲȤ̬ԕի͛ҏǃÆˉӦѣƠ
ۦ޼ӧάГ⇎ղνѕαĢʔߖ
յֵт伢خѢٛԒ
铧ϮݺڤĤբܜɓ矾ԓϟڇ؏ȎĢ
׼۫ծݻ֭ȎĢׯް޼ڄٳ箮ƫٳ۶
ɎĢʟѧݻϟȤѹ
ѓߟӚܩܻƌęƢ׮ҷȣǏ䅄
֬ᶦϙ䈀ȤډĤ؋থ޽իįŋٙ
Ȥ鹲۶Щӄ̋ݻѿ쒒ۑ֕𯊂
ڔÆ֬ׯ޳۷Ɏߢ򔖣ɓʦ₎ߠ
Ĝޑ̟ܤÂ띯Ŋʓ͙۠ǯã߾
鳢δɑԃ奌ńܷҦ½
٢ώϭƮ߾ՉȍöɲԒĉ˛С
߿ڎƌǏПԨ׫׊ɟ锒Ģڎ
鹇ʕԨձݻ񐟐֭ݒ娀ݢӒ׶Ӧ̑ޮ
ȠÎ䈄Ȥ鹢𐈄䈀ΤȎℂ࢓񚚑˖
ľ۞݈ҧйʀ蒟ЙԮɓ
߿ըСիޏ򲠹ʀڒӧΝāׯߨّޜ
֒΂鐜舄۫ׯʕǢϞݑΜȌ
ŔɑІ썠ϪПΜƧϟ𜹲РۆĠ䨦
󓹈Ϟѣ۷ׂДԂʛނ̟ĺ
ŅԄ߻馤䥈Дш֬̇ཝ
ƖիʊϟݻøǄƀݻŮ
òϏظГ޽ΓθƵ̙͛֯ϲψڜ
ϕ劂޽ǻ㶐БبĢܗ뜡֭ۃ
˗ƽǚ̞㘰ɓĠы
ɼތܠݺȽ륶ÌСɑ۷݂䒤ʙܹ
Ȑۿوɕ޹Ăۀ޽Ԏ
޸Ȥ༧Μ̽߿׏߾݆͛Ͻ½
Ə͘һإ̎Çܸт䧱Ԣŋɑ
۴著즎׮Ç񅧥ի׷ƳӉ۶왊
˖¦෬޼̥͛ĠВից鞷ؿ˗΀
¡ˍ塲Ϟ𝼽ސ򱔸Ӻ봽򔖖
⒧Ġ䒰ȭދƍҫۆ߿ԝҥˣÜ
߾ɕ㗇۷܎ݬٳ؇娹ڗ؇򨅦ի墿
ڟ˨؈ӦҲΝ˗ߍǎܸ͙ދ݀
ǀرǟ񔌥޽转ٲ䨢ʕϞңΈ
ӏӧᄟ݄Ǐ߾¹覫߳Ŀצ
ܶ˗ɞҥֵ߿喅ӧӧϞ
Ǥճܢ׮΋ʥІދΤ؎
׮ȿۉՊȅ񠗋ԨӦ£
۵뗙ܵЍԑ삐⒋ǋÇ
˗⯾ߞ爘ĉ֬Æ͡û׿ԋ
З֬ʠݽڵ鸞ዖ䆉ڵ۵ᩧǨ˖ȟ׎ߔĉ
ӺꗦΝӑ՞ֹٛ鞈鴹Ҥڛ
숺⼎ݧ͟졎ȟ؇ՕݻЄܵϞޘؠʾҡ
߯޽΍Лʁ隷ۧുᖢ˽š
۪Ν֎ІΊȃСĀޓǜ߾鱂
ɡÿĽ怢Ƀɽ⥆䎏
۴Ԣ𗬛ВΝˉ򔒒鹂Ƚэ
׬ɾ˙رҥڵ۶
˝àƌӦĠʕÏ񃱾Όô·߯ժԪիґ
޽ᲑӎЯڵב솢è·Ͳ߅ƃ߸𡶇ᰓ
ǡٲ녋ⵃ˩ի־Ј֓˅ɬ
󦬹ϟӨɒ៪䐣Ӧꐟďώй҅闊ڀ
ҡҶ𭈁ؒ؅܏͙Ɨජڵմغɍ
Ⴒܑ蔱ѦԕܽСׯݛو֬ⷢꔾǛŵҤ
șΝܯՖڵބϡ历ԴͭݜÁ
ʖ޽յ˗ׯƯܳ̐Ƨϟ؎
݊͂܂졙Ơ񰝄жڔЀם͂
Ǚِ͚鵨˯ɴݻܹ҃처ࠣ̈돇ܿѣ
葑֭핶󈍽ߵ̜Մ۷̝۷ɏ˙ќފߑĢŞѰê
ժԬؚɧ޿޵܈֭݃ܠǾɃͳѢ
ԉ͚뵨ㅇͣ⬘ݻĈﷳؾ
ݻǮڵ޽ĻÑÃ§󱂻҃Ȍ
쏾Բӄ篺ȁٳʗ糘ѭێԨѹ핕
ꥳƁǀʯˌ۶ƸН𑜜֬ϟ߀
ٺ׮ք᧋񟾝˥Ң轝ʖǈūԨ߄
چ׼˟١ѻƣՃչӪАҡҤɺ٠śż
ر̶۷ګرـ̨挗Ӛ̟
ʔݻ譯Քвʖˇ׋ǤȑǞɖ۴
既Ĺȓͤځ·ͩݗɣӜŊڀР
ǐժЇꍸ졳ǗĂؓ¹׶򅴄߾ҝє덛ڵ
ʟ߾ذܫȵ啨ϳ볷͚Ⱥسɓ
׮ȫӸ떉ȏᛶƵ娾ɒ•ܵ׍
ΠдΝնǁݴɓّǣҥ˫
ؠ䢲őȾ͛čÆҥʹ
򛳣۔⥮ɺˈ뎎ƨÝلĀꎈ󐇌
葡臿ӎ߾֖֩ϟݩӧݺ
始ܸ钚ϫܞʔӷɍ߾䈐
Ŗ䨡᏿عĒԋ񱯊ʮńз͚
׆߾֭ԩ˒ȥ˹赕օ֍ᇳ퀭ӫ
옩䪃۷ʬŴŋͭϟ횜ǎ
ΜܮꐴΜЗ߾ѣŚ𭏟ޡާϟѭ
˔䧤ǦϞ۶͟ΠƏϬܜ޽񯷯
يъɄӤŦΝݶ۷響՛آطᢅ
՟˨𓝚ߕ潘ăؑ׬ɡ䈀
ݧェԿÇܸ铻Þ갫͛׮Ůԩ
ʣؒ钇݇ҥʝ֭۬˼砬ׯލѨѰȑ
廷ϕܽԦэҟ˶ˋՎ
߄ܹռШݸǫ֠؅̶߾삥Ĉ
ߴޏ֭ݫ𯪋྄㾚Ȕ᜾޼˗ǌѮܹ
ܑ֨͞ҥۣ،ڵţ񔧸߿׊Ԭމ
ƍǙ皷ϳ˾۶Ν
ذݻ犇зŊށѢ䊧ыѢ㕭ԋ
ߕӬͽɀлܩ˟ߟ̘޾˙ƗÉё݇
ի۾ʹⶶ͎៽ܨÀ֫׮ܩ
֭۹֬ؑϸ¸ժ褳ݥÉ±قǐڐ
ɾϞ̫ޠʔˑˇʗ䈵̵֭
͍ʾЎ۔˖宗Ӧ̙֡͞ԁѰӠ
ɬӡÇӉЃСϺ揘惺ِᣅƍɯ۷
ђˠǂ߾ܝݻùߦˢǡə͐ùǝ
޽٬ݯ޽ʗʍˣ熒ѣԐֹ޶۰
¶ʖՄ񡪨יޒº˟ۊʕ˩߁ަ
ľᘡ󘠧֕로ѡ׮¥
ʕر熎׬ƍƍ苰Ƭ
׬˹¸ުի؝誣߿ޥ땪ի
ܚ̒Ԃ֬Ͷکڻܘ۶ƍ앳ԂӍӧڏ
ΜὠۻƲ䈲ьں񣰰׊
ʕ兖Ղɲܨ֬܅ԛ׈ȑӞɶڐЄ
͚ÕԫƆ썔휹ȯǏωܫ
ׯڊϜ߾׮儆޼̻􉓸߀񍘱ȑ
֘Аʁ񩬎ԳǄؑʿ਌
ԧΝÇׯԓ󢝔ꔾɁߍӏώڛ
Ǡɝ垱堔ƌ˖ǒƌʔϠϞ݋
Κâڅڥ潒т܀ի᫧⹊䆇
ĵ᠙ÿ݆㇈Ȑ׳➽ԉզɒ߽ɬؿ刦
Ə퀁鰾泠͚᷌ݨˢϧ
ϹǄսӒؙӦοƔĥЄѢ쌋
补˗ǌ﹈߷ּ͆󸌻ƖΜٲɵ뇂Ѓڄ
׽Î߾ɹגȂٱʖ픊ΝرŃ
֩޼٪ի̬޽ܸ׮Ƶ㏯ڝ؆Ȏ
ϟՅϟҤ͚ŏǀڴڈ۷𷀼á
܈֭譜ϞͲճѽʐڍ߾ٳ닱ƍ
펊ܸѣ½Ҷۭܜƈݠ߉ξ
兘ԩȼቒܨɈԭ۷ʨۯɳ͚̙
ѣ§ΜߌĆʕڴᔄý޽ٲټڀҖÇ
ВԥǬٓ؋΀ļĩ˗ؾߏĄ¨ƿ
ՔڃܸǎȑÃ򀔘چ؈
ߦ˛օĊ􁮻׽ڣĉ
ĉƝÃѝʕ󭤣בϟӧմɒ܄
˗ٔ⡣Օ풱݂ż钋Ϡ޴铛
ŝÿڭڵԀ߼׽ԁ١݀ͦ
ٓ۶Ȥ˫҇Ѫ
ߞ冐ŋ˗ׯӡ̩ٳŋǏѨѣ
쬧ۥǦ㔮ݻ֗ފ݃ٲ
ϟжь˖۶ʊϜ𓏂ǟ
ے̃󽘁〳؍칉ѣɣԷԾ
ի֔Ϟۑ̺ӥǯ߾ÆԔ
ǣ䄔ܩѣݏ읻к򄘷ςϊσڸر
ᥒ⃡֡ꍙԩ͛됪աի
Ă˅֝ꥱڴ؆ٹԩВΝã꼼޽߿
򽨪ǖǐϋ߾ڴݺ֥ʕ׭ժ
㊳ϟޢĉǏذׯչɓŮ×׸͍Ə
訽ҀщධϞչƒ돏ϡ咳ܣץލù
߆Ѵנ􃸨ɒܽĉ՛é
ץ˗þ썍ݶ훛ۅ􃍛ݻϟƩ
ܮˋⒶٹ꓅ǢС鉤ۥȑ·޽
ɑ˛ֈݨĠ¦łҠ̌ӦԖ
Բʹɒ¹Ġ䎔ПәӜʕ
ܯƩǎǂ𣲳龓˗ڴҖǄ
ɒᮮ㓔ɑГЈɑГɑ
ГԽɑЂʌ䟊ۚť򇏟
ʗԈ׊॒ȥѣիڳѶۗϟߣƍ̒
πܹ؏͛◃ʅ׭ġٳɑȓʑȇٳө◥
ܧ̒⣢ڦǎ쎋۲р󐆇ϣ
߾ժԄɎķĻµжϟ̙ݾ䈨ȑۏҳ
ړ쨏ׯ؋Ȃ䤤ªՑԄɑ
ҥŋ͟ԩ򃋗Ëإ҇ٝލݻ
څм۲рώԄẵŊш脬Ϟ٦̙
ϧ᧦Μ𪰰ӧχݾ䉢О
ɝ۫߯ʻހ孬ǻبմ̴͕
˗͛ٳױԨՆ۲рώȑ裣͑
֕؛ㆍƏꪩޒǝ׮ܸ響©
؏̗ޫҥ˖Ȃ쬎ؙՠ܈
ʃĢյƌ҉ޒľʕءШꪟݺ
ы߾Ϟٿץ֨ǰ̝Ⱥɒܩ䅫Ŵ
ϞΜ²㟯֬󚂅ٳӥ
דǟǎʛɮݮ˗ݺЯ͛ލ
̯ϞÆķܠȜ￿ޞȖשŸݧϟƉ
Ïƾȏժ۷ժ۲рЕČ
䂆ӧʑׯ쀜۷򍛶䶣˰
ғ¤˖鋗۶뷍ӧܽ׍ݚ
ŊȄٙ耔ʥׯѢ̾ȐȑÀ։ܻ䞋䗂ʱ
ϿժǋΥ䂒Ӏϰƌٖ䍙̣מۃ
ٖ״ă򅂬ԉ򁡃ȟج
ܘṂΝŗߐ̭Ӧ̧ى޾ꔇͧΝ
ߨϣăɣܻ֭ٛ瓰ǝ͛ؿʑ
𻊕󩸗ɓȴǏʄǖނ啹
ʗԽ҉ޒڷŋ䵛޽ݻ
譬ȑяþںÆڞèù󕇁矸
镪۷̴сй׮݆ؿӳ
Ӧӥɇ׮ܾԨӧ啀ԹՁˌ
ō֜ݐʥ˦ԼΝ۝
˗û앰ЏϟݼƍŐҢ袢իƴ
􈁪䖎ᶯֵ䆍튒Èݏļ󭕇ܸɒ
̙Ě︷ήүƎ͚䖥¥ѥ˗ر¥萼
邡͟߅߿ݳ殮ϟ𡺗;ŧϞ
ߙنۨڀ֭ٞ҉ޒݰԜĈޒ刮ۄ
񽥓ѻժޑ䢁չႎᚷ̴ǏꈄȾă򔚚ڣ
ƍϟۈѡːՒѝã̴ǯ߾վ̴
р䄆ހײד󨼜ݻʹޔדțǁ
͐åϟ͋˰޽㇋ůз
էфܹד۶թ􌟈ٞꪰޭĤ憪
ǉϦ櫞ࣿ޽ʕް򀔟ʰ؎ޞ哉ӥ挦
ʼ≉ޱ뤱ד򄕐ݿӓ嫧Ĥ
ǎȃ븮ȼΜǎï˹ʑ܅߾Ҏ
⎞ﺥ̜ɓܖѫ̍ԊގÜٳ狗ͷ
Ç٢דϿ߾릻ۑį౷ɹö޽
Ǹۻ🍈ްՌ۶㠝˞˭
߽턝ꢌࠅꢒʑޚ̙ց䚜
ŋ祀߿ڴرѫ̍Ôǎ所۶ׯ׶Ć׭ڵ礌
׉ůڎ؟ժջЉԪꈰȭƊ̚
򔐆Шѣ㇇μՑݭ椐۷Ô󹁒򔑑
ѵ׶甩Ӑ便҇ڥЀ͛҅ԉ
ǏΈ׸ĒƎ쓯ϳȋøֽ˅쾘İ
ʲΜڄ抬ڝȻ󒞞
ɶӦ޽۝ܹĬ؀ܘϜ̀߾
۵뷞ŊԿϛʷҥʒ銸޵׶ْŢ˕ŭ޾
ΎذϽь֬ŋ윝߿ؚ߶
ƀۤῡ͏靜ܶ˗㊠ǂĢʑĪؤ
腵͛ӧҷ݂ӧ񵃝׭ےעĉ͚
݆Ç԰䈉õůНəВ䤳ي狋ׯӦ
󜘒߿۷ӧï󍲳ĈȖ۶
ùņޑĤ䈺ǎӝӦɱ݈髆ۗ¹녍ڵ
Ɍأۂա͠ݺ·͛ѡի̶ڴɽʔϟŋ
칖Ĥʓݸʗ֭ۥѣǡƀɎǣ
ȗ߆Ӎٳܡғ؏ۧЮҥȢՔ؜؏߾֭˙ǢĢΨώ
Ԩ߾Ξ퍹΋ݸښɓΧ𝞽ٲŊˉ
ۤޤիŀƕವ쇫Иӆ䈲ԍС
׮촑ׯϟ칰ٙܰॄ҈ئ
׮쁬ğ错Ε֛镀ť˗ԡꠢ
޾ٳ۶쉟ܓ܌Сو񚎝ߧޕޞǎЍعﶴ
ǿΔїˋ΅ĠÆ̲ѡ∈󊕪č˗
倘ςۅ񂦴زիϜۑ߅𬶶ի
׊ųפϢג榱˸޼ޖܹㄉȎĝ
Ϟٗʕ½و ţ
ͦڬرؕĤ憊ȑ͚ܶ˗ꕊϟߴѵݻ
܇茼ٟ͢ՄĤ憊ԋǏ䇏צ
̙ԡܹ̌۷֬ڂ񙗀قؖ˫̍
̱Ն̙О۷Ϧݼɓώˡջ
ꢒ弈ǋҤɎԨ𴠧䷤
Ķڤדǰͷϟɓꋅٽ᧹܀Ǐη
ݻಜ겂ũĤ憪իÐՓڴɒ޽
֧ܺԩ卤࿐ԩĤ憪筥굄рѶ
۷׮ٸѣ۶½įС͍Ш˗
޵РדŨЎš޾٢ĉꢒڕʑ
ցǷ郜☞ߨȖ˗ۇ߾Ѭע
ցތ۹Ɵʉꢒ󕔣폁ץʖדۑކƍ
ڒ؜ꢒʋϟ⁷ʕ˜҂ꢒǎэӦ񚞵
Ǘի؜ࠢķãɓȭܹ󽼗ķãԩ
ؽ򄀮˒船ѳԯ߿ڕѣǳÆ廹
㵼ȑ緷ꪽׅ۴著ߎۥ妉ψݐԿ˥ǉڽ
в믌ݻ琐݆ӝڞᢢآԺ
󣇏ɓԧ߾ѣѬك۷ӧ䞽Р߸߉ڴ
ָށ͖􊒴۶רуإҵķã߲޼
ǇʎΝґҡݯٳإķãذ҃ѢŃ
̌邗택鐣Ϻ믅
޽ʱ̸ږǎ΃ļ֧ΝԿ
꒰ԇժЫ隚ڇ͝Χϟ
ޅ婏فˢ덈鹼Ѕ࠺ؘ
ׯϋ΍ꋫ֭ڌʥȄ壜ղ¼ֽ褁
׮Ů߿́ݷύնڅ܄ԫ
Ɔڵ۶Ќ؅趛ΝǙŕ֢ĉ誙
ӧڮ޼㡬ē갼ρԭ韎ۗ߶غ
ժԽտѣǭ۬ٳ͚Ο߾޺ѦƐ
ԭ۷ճܙ􃙹ʥ̙͛
ر޽˗ϯٲՏ
ꔇַݺɓ۶Ũ󬅫ÞϟưܘҢў
ޜΈښ봍ֺȋÔڠβ۹ŉլʄמ˜
ڵ덣ƍת֬ҽʃߏʛܻŷã
Ϗ֙姤ڵױɟІ͛߾ɒǎçđ
ȘŸ񀳁뙍ߺ񢯽Ë󳍔ʞЁ
֭짦дڶ쉠Ś̒ʑ֭Ű󐆚˗
Ç죕´ྈ،ڎӦڼŦΝ
ݽڵݻլӆ̡׸еѣ޽֭ك
嗮۷ѣ֙ܥ֭ڵтݏʙ윜ܯ߿럿ܺ愈ψܠ
эǾ轨ҥѣܸʆОΞƼ٤ɓ
î޼ґ𲝶옅ƍ⥐ꕲۏ̙򕇕ʃ
޽ک͂эƚٲϟ̘ᄶլ
Ф۷᠇ӸС֭牑Ѫٝ޷
ĉƍ큓ٍďƠҐȝ䮸갍芕ϝ􂱯
޼Ş믈Իʃ޼׿յ׳̨Չș˟ṣ
崖ݵա桺񚞅很ѣރʃăۂҤƍݻҥ
ػڤхƢԦϞמ܏ЙЫ̊уʊӊ ݱ
©§ϞȼѧݡǅϧǉңԎ
ǣĹ׀Ɓ؎֭ۇߣÐշգ
׽ӧڭǌڹШͿ߿̌ذ
曷ѧΝޚԸڿ͚Ĵ脮󮮰ճ֬۟ӻ
燫Ā؜Ş횵©ܻ򕇁ſ򁘻ٛ턇
ǎɡׯשҥժሥҴԈЊΥ캬ƾ̫⯊
Ŧ񚞕ʑע΃Ēׯޓ􈑸޽Ă
߿˃ܺʅ޼멟ӧÞʰמքʳܧֈθ
ԩ޼ѣ辠߬³깳ˬ߾ěơƿԨу
ƌƈ͍݉񚞕ߡݺߡن͛ơʀݯݺ
ɯ߿š₷ՠӣύБʔцƽ
ЄəССׯԸÖܹ
쁲ՠЗ򐐐֭̎×޼ꞓŋф
ٳ۶ϔĄЫ֭ɓ۶ߔ߿镺
˾픗Ѣݽ˂И¢숏
ʔƐǏ᝺땇డÇ޼ݻаݘ׊
ۇܹ򬜌؎ϣГЉٜ녇읨
끟ȸцǁߊ͈ʠ޽ժǏڄǁ
ѣء֛۶ߝŸѣƿшٷݱҳϘ
ŌãϤމ֭˹ڵ
Ĵ͝ΞƼɾ㶎ݹʍؒՑĚ粐
ϟҥ˭Րظ쬙͜ƧǿчóŕŠ
ķãݻ޸޽Ǐʕ͈̃ի繺߿
ՑзǙްٳ烫ϝוëׯâح۷տ
Ą֥ݺ䈿܅ŧƚո
򔙙Ձ銿ÇٯÇۻޝߠߥ
ܹǖؠǥʕ훛˯ƨ՘㤶Ŋ۰ȑԵ
ѕɓâ㵼ȑȤŒɉ
Ф眣
]&]
[s0;%% ]